<template>
  <div class="app-container">
    <div class="filter-container">

      <el-input size="mini" v-model="search.keyWord" placeholder="关键字" style="width: 200px;" class="filter-item" />
      <el-button size="mini" class="filter-item" type="primary" icon="el-icon-search" @click="searchData">
        搜索
      </el-button>

      <el-button
        class="filter-item"
        style="margin-left: 10px;"
        type="primary"
        size="mini"
        icon="el-icon-plus"
        @click="handleCreateAdd">
        增加对接订单网站信息
      </el-button>
    </div>
    <el-table
      :data="tableData"
      v-loading="listLoading"
      style="width: 100%;margin-bottom: 20px;"
      row-key="id"
      border
      size="mini"
      default-expand-all>
      <el-table-column label="操作" align="center" width="230" class-name="small-padding fixed-width">
        <template slot-scope="{row}">
          <el-button @click="handleUpdate(row.id)" type="primary" size="mini">
            编辑
          </el-button>
          <el-button @click="editStatus(row.id,'1')" type="danger" v-if="row.voidFlag==0" size="mini">
            禁用
          </el-button>
          <el-button @click="editStatus(row.id,'0')" v-else-if="row.voidFlag==1" size="mini">
            启用
          </el-button>

        </template>
      </el-table-column>
      <el-table-column
        prop="id"
        width="50"
        label="id">
      </el-table-column>

      <el-table-column
        prop="siteName"
        label="网站名称">
      </el-table-column>

      <el-table-column
        prop="siteUrl"
        label="网站地址">
      </el-table-column>
      <el-table-column
        prop="factoryAccount"
        label="对接工厂账号">
      </el-table-column>
      <el-table-column align="center" label="状态" class-name="status-col" width="100">
        <template slot-scope="{row}">
          <el-tag v-if="row.voidFlag==0" type="success">
            启用
          </el-tag>
          <el-tag v-else-if ="row.voidFlag==1" type="danger">
            禁用
          </el-tag>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="listData.total>0" :total="listData.total" :page.sync="listData.page" :limit.sync="listData.pageSize" @pagination="getTableInfo" />

    <el-dialog  :title="dialogTitle" :visible.sync="dialogVisible" width="500px">
      <el-form :model="form" label-width="130px" :rules="rules" ref="ruleForm" label-position="right">
        <el-form-item prop="siteName" label="网站名称">
          <el-input v-model="form.siteName"></el-input>
        </el-form-item>
        <el-form-item prop="siteName" label="网站地址">
          <el-input v-model="form.siteUrl"></el-input>
        </el-form-item>
        <el-form-item prop="siteName" label="对接工厂账号">
          <el-input v-model="form.factoryAccount"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="dialogStatus==='1'?addBtn('ruleForm'):editBtn('ruleForm')">确 定</el-button>
      </div>
    </el-dialog>
    <!--    <servicedialog @tableRefresh="tableRefresh" ref="menuDialog" :dialogStatus="dialogStatus" :menuId="menuId" :titleDialog="titleDialog" :dialogVisible="dialogVisible"/>-->
    <cancledialog @tableRefresh="tableRefresh" ref="confirmDialog"></cancledialog>
  </div>
</template>

<script>
import { queryOrderSite, addOrderSite, getOrderSite, updateOrderSite } from '@/api/baseInfo/remoteOrder'
import Cancledialog from '@/components/Dialog/Cancledialog.vue'
import Pagination from '@/components/Pagination'

var form = {
  id: '',
  siteName: '', // 网站名称,
  siteUrl: '', // 网站地址,
  factoryAccount: '', // 对接工厂账号,
}

export default {
  components: {
    Cancledialog, Pagination
  },
  filters: {
    statusFilter(status) {
      const statusMap = {
        1: 'success',
        0: 'danger'
      }
      return statusMap[status]
    }
  },
  data() {
    return {
      dialogStatus: 1, // 1增加，2修改
      dialogTitle: '',
      dialogVisible: false,
      search: {
        keyWord: ''
      },
      ruleForm: {
        modeName: ''
      },
      form: Object.assign({}, form),
      rules: {
        modeName: [
          { required: true, message: '请填写对接订单网站信息名称', trigger: 'blur' }
        ]

      },
      listData: {
        total: 0,
        page: 1,
        pageSize: 10
      },
      confirmdialog: false,
      listLoading: false,
      tableData: [],
      menuId: ''
    }
  },
  mounted() {
    this.getTableInfo()
  },
  methods: {
    // 获取列表
    getTableInfo() {
      const _that = this
      _that.listLoading = true
      var params = _that.search
      var page = {
        pageIndex: _that.listData.page,
        pageSize: _that.listData.pageSize
      }
      var data = {
        'params': JSON.stringify(params),
        'page': JSON.stringify(page)
      }
      // console.log(data);
      queryOrderSite(data).then(response => {
        // console.log("tableData",response)
        const data = response.data
        // //  组合表单数据
        _that.tableData = data
        _that.listData.total = response.total
        // console.log(_that.tableData)
        _that.listLoading = false
      }).catch(err => {
        _that.listLoading = false
      })
    },
    // 增加对接订单网站信息
    handleCreateAdd() {
      const _that = this
      _that.form = Object.assign({}, form)
      _that.dialogTitle = '增加对接订单网站信息'
      _that.dialogStatus = '1'
      _that.dialogVisible = true
    },
    // 刷新表格
    tableRefresh() {
      // 刷新变革
      this.getTableInfo()
    },
    // 增加
    addBtn(formName) {
      const _that = this
      _that.$refs[formName].validate((valid) => {
        console.log(valid)
        if (valid) {
          var info = JSON.stringify(_that.form)
          console.log(info)
          var data = {
            'orderSite': info
          }

          // console.log("clientLevel",data);
          addOrderSite(data).then(res => {
            // console.log(res);
            if (res.httpCode == 200) {
              _that.dialogVisible = false
              _that.$message({
                message: '增加成功',
                type: 'success'
              })
              _that.tableRefresh()
            } else {
              _that.$message.error(res.msg)
            }
          }).catch(err => {
            _that.$message.error(err)
            _that.dialogVisible = true
          })
        } else {
          console.log('error submit!!')
          return false
        }
      })
    },

    // 唤起修改
    handleUpdate(id) {
      const _that = this

      _that.dialogTitle = '修改对接订单网站信息'
      _that.dialogVisible = true
      _that.dialogStatus = '2'
      var data = {
        idOrderSite:id
      }
      getOrderSite(data).then(res => {
        console.log(res);
        const data = res.data

        _that.form = {
          id: data.id,
          siteName: data.siteName, // 网站名称,
          siteUrl: data.siteUrl, // 网站地址,
          factoryAccount: data.factoryAccount, // 对接工厂账号,
        }
      }).catch(err => {
        _that.$message.error(err)
      })
    },
    // 修改档案
    editBtn(formName) {
      const _that = this
      _that.$refs[formName].validate((valid) => {
        var info = JSON.stringify(_that.form)
        console.log(_that.ruleForm)
        var data = {
          'orderSite': info
        }
        // console.log(data);
        updateOrderSite(data).then(res => {
          // console.log(res);
          if (res.httpCode == 200) {
            _that.dialogVisible = false
            _that.$message({
              message: '修改成功',
              type: 'success'
            })
            _that.tableRefresh()
          } else {
            _that.$message.error(res.msg)
          }
        }).catch(err => {
          _that.$message.error(err)
          _that.dialogVisible = true
        })
      })
    },

    // 启用禁用
    editStatus(id, voidFlag) {
      var _that = this
      var data = {
        id: id,
        voidFlag: voidFlag
      }
      var params = {
        'orderSite': JSON.stringify(data)
      }

      var url = '/doc/voidOrderSite'
      _that.$refs.confirmDialog.updataClick(params, url)
    },

    // 搜索
    searchData() {
      this.listData.page = 1
      this.getTableInfo()
    }
  }
}
</script>

<style lang="scss" scoped>
  .filter-container {
    margin-bottom: 15px;
  }
</style>
